[![license](https://img.shields.io/badge/License-MIT-yellow.svg)](https://opensource.org/licenses/MIT)
[![code-style](https://img.shields.io/badge/code%20style-black-000000.svg)](https://github.com/psf/black)
[![pypi](https://img.shields.io/pypi/v/lightorch)](https://pypi.org/project/lightorch)

# LighTorch

<p align="center">
  <img src="https://raw.githubusercontent.com/Jorgedavyd/LighTorch/main/docs/source/logo.png" height = 350 width = 350 />
</p>

A Pytorch and Lightning based framework for research and ml pipeline automation.

# Modules
Set useful architectures for several tasks.
- Fourier Convolution.
- Partial Convolution. (Optimized implementation)
- Grouped Query Attention, Multi Query Attention, Multi Head Attention. (Interpretative usage)
- Normalization methods.
- Positional encoding methods.
- Embedding methods.
- Useful criterions.
- Useful utilities.
- Built-in Default Feed Forward Networks.
- Adaptation for $\mathbb{C}$ modules.

# Features
- Built in Module class for:
    - Adversarial training.
    - Supervised, Self-supervised training.
- Multi-Objective optimization and Hyperparameter tuning with optuna.
- Built-in default architectures: Transformers, VAEs, autoencoders for direct training on given data.

## Contact  

- [Linkedin](https://www.linkedin.com/in/jorge-david-enciso-mart%C3%ADnez-149977265/)
- [GitHub](https://github.com/Jorgedavyd)
- Email: jorged.encyso@gmail.com
